#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import string
from http.server import HTTPServer, BaseHTTPRequestHandler
from io import BytesIO
import base64


NULL_CHAR = chr(0)

colors = {
    "Z": "a",  # Black
    "B": "b",  # Blue
    "G": "c",  # Green
    "M": "d",  # Magenta
    "R": "e",  # Red
    "P": "f",  # Pink
    "Y": "g",  # Yellow
    "W": "h",  # White
    "z": "i",  # Light Black
    "b": "j",  # Light Blue
    "g": "k",  # Light Green
    "m": "l",  # Light Magenta
    "r": "m",  # Light Red
    "p": "n",  # Light Pink
    "y": "o",  # Light Yellow
    "w": "p"  # Light White
}

def write_report(report):
    with open('/dev/hidg0', 'rb+') as fd:
        fd.write(report.encode())


def release_keys():
    write_report(NULL_CHAR*8)


def printchar(c):
    if c.islower():
        write_report(NULL_CHAR*2+chr(4 + ord(c) - ord('a'))+NULL_CHAR*5)
    elif c.isupper():
        write_report(chr(32)+NULL_CHAR+chr(4 + ord(c) - ord('A'))+NULL_CHAR*5)
    elif c.isdigit():
        write_report(NULL_CHAR*2+chr(0x1e + ((ord(c) - ord('0') - 1) % 10))+NULL_CHAR*5)
    elif c == ' ':
        write_report(NULL_CHAR*2+chr(44)+NULL_CHAR*5)
    elif c == '\n':
        write_report(NULL_CHAR*2+chr(40)+NULL_CHAR*5)
    else:
        write_report(chr(32)+NULL_CHAR+chr(0x38)+NULL_CHAR*5)
    release_keys()


def change_color(background: str, foreground: str):
    if background in colors and foreground in colors and background.isupper():
        # DELETE keypress
        write_report(NULL_CHAR*2+chr(0x2a)+NULL_CHAR*5)
        release_keys()
        write_report(NULL_CHAR*2+chr(4 + ord(colors[background]) - ord('a'))+NULL_CHAR*5)
        release_keys()
        write_report(NULL_CHAR*2+chr(4 + ord(colors[foreground]) - ord('a'))+NULL_CHAR*5)
    else:
        write_report(chr(32)+NULL_CHAR+chr(0x38)+NULL_CHAR*5)
    release_keys()


def printstring(s):
    last_c = ''
    last_last_c = ''
    for c in s:
        if last_last_c == '§':
            change_color(last_c, c)
        elif c != '§' and last_c != '§':
            printchar(c)
        last_c, last_last_c = c, last_c


def reset_color():
    change_color('Z', 'g')
    release_keys()


class SimpleHTTPRequestHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        self.send_response(200)
        self.end_headers()
        self.wfile.write(b'Hello, world!')

    def do_POST(self):
        print(self.headers)
        message = base64.b64decode(self.headers['X-Messages']).decode('utf8')
        self.send_response(200)
        self.end_headers()
        response = BytesIO()
        response.write(b'This is POST request. ')
        response.write(b'Received: ')
        self.wfile.write(response.getvalue())
        if message == 'reset':
            printstring('\n' * 32)
        else:
            printstring(message + '\n')
        reset_color()


httpd = HTTPServer(('0.0.0.0', 8000), SimpleHTTPRequestHandler)
httpd.serve_forever()
